# BulkBarrage

BulkBarrage is a command-line tool that enables users to report spam emails to
the SignalSpam platform <signal-spam.fr>.

This tool serves as a bridge between individual users and the SignalSpam
service, facilitating the process of submitting spam for official investigation
and action.

## Introduction

BulkBarrage is a community-driven project developed independently from
SignalSpam. It offers a convenient way for users to report spam emails directly
from any email-piping capable mail client by leveraging the HTML forms on
SignalSpam's web platform. The project is currently in beta but is mature
enough for daily use.

## Requirements

To use the project:

* An account on SignalSpam.

To build the project from source:

* GNU Make,
* CrystalLang and Shards.

## Installation

To install BulkBarrage, follow these steps:

1. Ensure that CrystalLang is installed on your system.
2. Clone the repository:

   ```bash
   git clone https://github.com/your-repo/bulkbarrage.git
   cd bulkbarrage
   ```

3. Use the Makefile to build the project:

   ```bash
   make build
   ```

## Usage

BulkBarrage can be used in a few simple steps:

```bash
Usage: bulkbarrage [options] [command]

Commands:
  configure        Initialize the configuration
  report           Process and report spam email (default: from STDIN)

Options:
  -h, --help       Show this help
```

### Reporting Spam

To report a spam email, you can use the `report` command:

```bash
cat spam_email.eml | bulkbarrage send
```

## Configuration

After installation, run `bulkbarrage configure` to set up your user
configuration, which may include credentials or preferences for interacting
with the SignalSpam platform.

## Issue Reporting

Issues can be reported on BulkBarrage's Issue Tracker.

## License

This project is licensed under the LGPL-3.0-or-later.

## Acknowledgments and thanks

* SignalSpam for their efforts in combating spam.
* The CrystalLang community for support and resources.

## Alternatives

For alternative solutions or more information on SignalSpam, you can refer to:

- [SignalSpam's Official Blog Post](https://signal.eu.org/blog/wp-content/uploads/2007/05/signalspam.txt)
- [Bortzmeyer's Guide on Reporting to Signal Spam](https://www.bortzmeyer.org/signaler-a-signal-spam.html)

